DL_GroupParameters_LUC Class Reference

LUC GroupParameters specialization. More...

`#include <luc.h>`

Inheritance diagram for DL_GroupParameters_LUC:

## Public Member Functions

bool | IsIdentity (const Integer &element) const
| Determines if an element is an identity.
void | SimultaneousExponentiate (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const
Element | MultiplyElements (const Element &a, const Element &b) const
Element | CascadeExponentiate (const Element &element1, const Integer &exponent1, const Element &element2, const Integer &exponent2) const
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value.
Public Member Functions inherited from DL_GroupParameters_IntegerBasedImpl< DL_GroupPrecomputation_LUC, DL_BasePrecomputation_LUC >
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object.
const DL_FixedBasePrecomputation< Element > & | GetBasePrecomputation () const
| Retrieves the group precomputation.
DL_FixedBasePrecomputation< Element > & | AccessBasePrecomputation ()
| Retrieves the group precomputation.
const Integer & | GetModulus () const
| Retrieve the modulus for the group.
const Integer & | GetGenerator () const
| Retrieves a reference to the group generator.
void | SetModulusAndSubgroupGenerator (const Integer &p, const Integer &g)
bool | operator== (const DL_GroupParameters_IntegerBasedImpl< DL_GroupPrecomputation_LUC, DL_BasePrecomputation_LUC > &rhs) const
bool | operator!= (const DL_GroupParameters_IntegerBasedImpl< DL_GroupPrecomputation_LUC, DL_BasePrecomputation_LUC > &rhs) const
Public Member Functions inherited from DL_GroupParametersImpl< DL_GroupPrecomputation_LUC, DL_BasePrecomputation_LUC, DL_GroupParameters_IntegerBased >
const DL_GroupPrecomputation< Element > & | GetGroupPrecomputation () const
| Retrieves the group precomputation.
const DL_FixedBasePrecomputation< Element > & | GetBasePrecomputation () const
| Retrieves the group precomputation.
DL_FixedBasePrecomputation< Element > & | AccessBasePrecomputation ()
| Retrieves the group precomputation.
Public Member Functions inherited from DL_GroupParameters_IntegerBased
void | Initialize (const DL_GroupParameters_IntegerBased &params)
| Initialize a group parameters over integers.
void | Initialize (RandomNumberGenerator &rng, unsigned int pbits)
| Create a group parameters over integers.
void | Initialize (const Integer &p, const Integer &g)
| Initialize a group parameters over integers.
void | Initialize (const Integer &p, const Integer &q, const Integer &g)
| Initialize a group parameters over integers.
void | BERDecode (BufferedTransformation &bt)
| Decode this object from a BufferedTransformation.
void | DEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation.
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &alg)
| Generate a random key.
const Integer & | GetSubgroupOrder () const
| Retrieves the subgroup order.
Integer | GetGroupOrder () const
| Retrieves the order of the group.
bool | ValidateGroup (RandomNumberGenerator &rng, unsigned int level) const
| Check the group for errors.
bool | ValidateElement (unsigned int level, const Integer &element, const DL_FixedBasePrecomputation< Integer > *precomp) const
| Check the element for errors.
bool | FastSubgroupCheckAvailable () const
| Determine if subgroup membership check is fast.
void | EncodeElement (bool reversible, const Element &element, byte *encoded) const
| Encodes the element.
unsigned int | GetEncodedElementSize (bool reversible) const
| Retrieve the encoded element's size.
Integer | DecodeElement (const byte *encoded, bool checkForGroupMembership) const
| Decodes the element.
Integer | ConvertElementToInteger (const Element &element) const
| Converts an element to an Integer.
Integer | GetMaxExponent () const
| Retrieve the maximum exponent for the group.
OID | GetAlgorithmID () const
| Retrieve the OID of the algorithm.
void | SetSubgroupOrder (const Integer &q)
| Set subgroup order.
Public Member Functions inherited from ASN1CryptoMaterial< DL_GroupParameters< Integer > >
void | Save (BufferedTransformation &bt) const
| DER encode ASN.1 object.
void | Load (BufferedTransformation &bt)
| BER decode ASN.1 object.
Public Member Functions inherited from ASN1Object
virtual void | BEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation.
Public Member Functions inherited from DL_GroupParameters< Integer >
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors.
bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation.
void | Precompute (unsigned int precomputationStorage=16)
| Perform precomputation.
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation.
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use.
virtual const Element & | GetSubgroupGenerator () const
| Retrieves the subgroup generator.
virtual void | SetSubgroupGenerator (const Element &base)
| Sets the subgroup generator.
virtual Element | ExponentiateBase (const Integer &exponent) const
| Exponentiates the base.
virtual Element | ExponentiateElement (const Element &base, const Integer &exponent) const
| Exponentiates an element.
virtual Integer | GetCofactor () const
| Retrieves the cofactor.
virtual void | SimultaneousExponentiate (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const=0
| Exponentiates a base to multiple exponents.
Public Member Functions inherited from GeneratableCryptoMaterial
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| Generate a random key or crypto parameters.
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors.
void | DoQuickSanityCheck () const
| Perform a quick sanity check.
Public Member Functions inherited from NameValuePairs
template<class T>
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject.
template<class T>
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object.
template<class T>
bool | GetValue (const char *name, T &value) const
| Get a named value.
template<class T>
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value.
CRYPTOPP_DLL std::string | GetValueNames () const
| Get a list of value names that can be retrieved.
CRYPTOPP_DLL bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int.
CRYPTOPP_DLL int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default.
CRYPTOPP_DLL bool | GetWord64Value (const char *name, word64 &value) const
| Get a named value with type word64.
CRYPTOPP_DLL word64 | GetWord64ValueWithDefault (const char *name, word64 defaultValue) const
| Get a named value with type word64, with default.
template<class T>
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair.
CRYPTOPP_DLL void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair.

## Additional Inherited Members

Public Types inherited from DL_GroupParameters_IntegerBasedImpl< DL_GroupPrecomputation_LUC, DL_BasePrecomputation_LUC >
typedef DL_GroupPrecomputation_LUC::Element | Element
Public Types inherited from DL_GroupParametersImpl< DL_GroupPrecomputation_LUC, DL_BasePrecomputation_LUC, DL_GroupParameters_IntegerBased >
typedef DL_GroupPrecomputation_LUC | GroupPrecomputation
typedef DL_GroupPrecomputation_LUC::Element | Element
typedef DL_BasePrecomputation_LUC | BasePrecomputation
Public Types inherited from DL_GroupParameters< Integer >
typedef Integer | Element
Static Public Member Functions inherited from DL_GroupParameters_IntegerBased
static std::string | StaticAlgorithmNamePrefix ()
Static Public Member Functions inherited from NameValuePairs
static CRYPTOPP_DLL void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present.

## Detailed Description

LUC GroupParameters specialization.

Since
  Crypto++ 2.1

Definition at line 223 of file luc.h.

## Constructor & Destructor Documentation

## ~DL_GroupParameters_LUC()

virtual DL_GroupParameters_LUC::~DL_GroupParameters_LUC | ( |  | ) |

inline virtual

Definition at line 226 of file luc.h.

## Member Function Documentation

## IsIdentity()

bool DL_GroupParameters_LUC::IsIdentity | ( | const Integer & | element | ) | const

inline virtual

Determines if an element is an identity.

Parameters

  element | element to check

Returns
  true if the element is an identity, false otherwise

The identity element or or neutral element is a special element in a group that leaves other elements unchanged when combined with it.

IsIdentity() must be implemented in a derived class.

Implements DL_GroupParameters< Integer >.

Definition at line 229 of file luc.h.

## SimultaneousExponentiate()

void DL_GroupParameters_LUC::SimultaneousExponentiate | ( | Element * | results,
|  | const Element & | base,
|  | const Integer * | exponents,
|  | unsigned int | exponentsCount ) const

Definition at line 45 of file luc.cpp.

## MultiplyElements()

Element DL_GroupParameters_LUC::MultiplyElements | ( | const Element & | a,
|  | const Element & | b ) const

inline

Definition at line 231 of file luc.h.

## CascadeExponentiate()

Element DL_GroupParameters_LUC::CascadeExponentiate | ( | const Element & | element1,
|  | const Integer & | exponent1,
|  | const Element & | element2,
|  | const Integer & | exponent2 ) const

inline

Definition at line 236 of file luc.h.

## GetVoidValue()

bool DL_GroupParameters_LUC::GetVoidValue | ( | const char * | name,
|  | const std::type_info & | valueType,
|  | void * | pValue ) const

inline virtual

Get a named value.

Parameters

  name | the name of the object or value to retrieve
  valueType | reference to a variable that receives the value
  pValue | void pointer to a variable that receives the value

Returns
  true if the value was retrieved, false otherwise

GetVoidValue() retrieves the value of name if it exists.

Note
  GetVoidValue() is an internal function and should be implemented by derived classes. Users should use one of the other functions instead.

See also
  GetValue(), GetValueWithDefault(), GetIntValue(), GetIntValueWithDefault(), GetRequiredParameter() and GetRequiredIntParameter()

Reimplemented from DL_GroupParameters_IntegerBasedImpl< DL_GroupPrecomputation_LUC, DL_BasePrecomputation_LUC >.

Definition at line 243 of file luc.h.

The documentation for this class was generated from the following files:

- luc.h
- luc.cpp